function ynew= heelstrike_turbo(y,m,R,Izz,...
p12x,p23x,pc1,pc2,pc3,pcs,p1k,etat,ls);

% specialized to 2D walker
% NOT optimized yet

cO1 = cos(y(1));
sO1 = sin(y(1));

cO2 = cos(y(2));
sO2 = sin(y(2));

cO3 = cos(y(3));
sO3 = sin(y(3));

R01=[cO1 -sO1 ;sO1 cO1];
R12=[cO2 -sO2 ;sO2 cO2];
R23=[cO3 -sO3 ;sO3 cO3];

R10=R01';
R21=R12';
R32=R23';

omega2 = y(4)+y(5);
omega3 = y(4)+y(5)+y(6);

v00=[0 R*y(4)]';
v11=R10*v00;
v22=R21*(ddcross(y(4),[p12x 0])+v11);
v33=R32*(ddcross(omega2,[p23x 0])+v22);

v1cm1 = v11+ddcross(y(4),pc1);
v2cm2 = v22+ddcross(omega2,pc2);
v3cm3 = v33+ddcross(omega3,pc3);
v1k1 = v11+ddcross(y(4),pcs);

% sum angular momentum about stance knee before heelstrike
% assume momentum conserved- if not, heelstrike will lock, not
% unlock this knee

rkcs = -p1k+pcs;
hpre(3) = crpr(rkcs,m(3).*v1k1)+Izz(3)*y(4);

% sum angular momentum about hip before heelstrike
rhc1 = -[p12x 0]'+pc1;
hpre(2)=crpr(rhc1,m(1).*v1cm1)+Izz(1)*y(4);

% sum angular momentum about new floor contact before heelstrike
r4cm1 = R10*[R 0]'+R12*((R23*[R-ls 0]')-[p23x 0]')-[p12x 0]'+pc1;
r4cm2 = R21*R10*[R 0]'+(R23*[R-ls 0]')-[p23x 0]'+pc2;
r4cm3 = R32*R21*R10*[R 0]'+[R-ls 0]'+pc3;
hpre(1) = crpr(r4cm1,m(1).*v1cm1)+Izz(1)*y(4)+...
 crpr(r4cm2,m(2).*v2cm2)+Izz(2)*omega2+...
 crpr(r4cm3,m(3).*v3cm3)+Izz(3)*omega3;


% now swap angles
y(1)=-y(1);
y(2)=pi-etat-2*y(1);

sO1 = -sO1;

cO2 = cos(y(2));
sO2 = sin(y(2));

cO3 = cos(y(3));
sO3 = sin(y(3));

R01=[cO1 -sO1 ;sO1 cO1];
R12=[cO2 -sO2 ;sO2 cO2];

R10=R01';
R21=R12';

% do recursion to get hpost matrix
% first, y(4)=1, y(5)=0 y(6)=0

y(4)=1;
omega2 = 1;
omega3 = 1;

v00=[0 R*y(4)]';
v11=R10*v00;
v22=R21*(ddcross(y(4),[p12x 0])+v11);
v33=R32*(ddcross(omega2,[p23x 0])+v22);

v1cm1 = v11+ddcross(y(4),pc1);
v2cm2 = v22+ddcross(omega2,pc2);
v3cm3 = v33+ddcross(omega3,pc3);
v1k1 = v11+ddcross(y(4),pcs);

% angular momentum about swing knee
hpost(3,1)=crpr(pc3,m(3).*v3cm3)+Izz(3)*omega3;

% angular momentum about hip
rhcm3 = R32*[p23x 0]'+pc3;
hpost(2,1)=crpr(pc2,m(2).*v2cm2)+Izz(2)*omega2+...
 crpr(rhcm3,m(3).*v3cm3)+Izz(3)*omega3;

% angular momentum about new contact point
r0cm1 = R10*[R 0]'+pc1;
r0cm2 = R21*(R10*[R 0]'+[p12x 0]')+pc2;
r0cm3 = R32*(R21*(R10*[R 0]'+[p12x 0]')+[p23x 0]')+pc3;
hpost(1,1)=crpr(r0cm1,m(1).*v1cm1)+Izz(1)*y(4)+...
 crpr(r0cm2,m(2).*v2cm2)+Izz(2)*omega2+...
 crpr(r0cm3,m(3).*v3cm3)+Izz(3)*omega3;

% now y(4)=0 y(5)=1 y(6)=0

y(4)=0;
omega2 = 1;
omega3 = 1;

v00=[0 R*y(4)]';
v11=R10*v00;
v22=R21*(ddcross(y(4),[p12x 0])+v11);
v33=R32*(ddcross(omega2,[p23x 0])+v22);

v1cm1 = v11+ddcross(y(4),pc1);
v2cm2 = v22+ddcross(omega2,pc2);
v3cm3 = v33+ddcross(omega3,pc3);
v1k1 = v11+ddcross(y(4),pcs);

% angular momentum about swing knee
hpost(3,2)=crpr(pc3,m(3).*v3cm3)+Izz(3)*omega3;

% angular momentum about hip
rhcm3 = R32*[p23x 0]'+pc3;
hpost(2,2)=crpr(pc2,m(2).*v2cm2)+Izz(2)*omega2+...
 crpr(rhcm3,m(3).*v3cm3)+Izz(3)*omega3;

% angular momentum about new contact point
r0cm1 = R10*[R 0]'+pc1;
r0cm2 = R21*(R10*[R 0]'+[p12x 0]')+pc2;
r0cm3 = R32*(R21*(R10*[R 0]'+[p12x 0]')+[p23x 0]')+pc3;
hpost(1,2)=crpr(r0cm1,m(1).*v1cm1)+Izz(1)*y(4)+...
 crpr(r0cm2,m(2).*v2cm2)+Izz(2)*omega2+...
 crpr(r0cm3,m(3).*v3cm3)+Izz(3)*omega3;

% now y(4)=y(5)=0 y(6)=1

y(4)=0;
omega2 = 0;
omega3 = 1;

v00=[0 R*y(4)]';
v11=R10*v00;
v22=R21*(ddcross(y(4),[p12x 0])+v11);
v33=R32*(ddcross(omega2,[p23x 0])+v22);

v1cm1 = v11+ddcross(y(4),pc1);
v2cm2 = v22+ddcross(omega2,pc2);
v3cm3 = v33+ddcross(omega3,pc3);
v1k1 = v11+ddcross(y(4),pcs);

% angular momentum about swing knee
hpost(3,3)=crpr(pc3,m(3).*v3cm3)+Izz(3)*omega3;

% angular momentum about hip
rhcm3 = R32*[p23x 0]'+pc3;
hpost(2,3)=crpr(pc2,m(2).*v2cm2)+Izz(2)*omega2+...
 crpr(rhcm3,m(3).*v3cm3)+Izz(3)*omega3;

% angular momentum about new contact point
r0cm1 = R10*[R 0]'+pc1;
r0cm2 = R21*(R10*[R 0]'+[p12x 0]')+pc2;
r0cm3 = R32*(R21*(R10*[R 0]'+[p12x 0]')+[p23x 0]')+pc3;
hpost(1,3)=crpr(r0cm1,m(1).*v1cm1)+Izz(1)*y(4)+...
 crpr(r0cm2,m(2).*v2cm2)+Izz(2)*omega2+...
 crpr(r0cm3,m(3).*v3cm3)+Izz(3)*omega3;

Odot = hpost\hpre';

ynew = [y(1) y(2) y(3) Odot(1) Odot(2) Odot(3)]';
