function ynew = kneestrike_turbo(y,m,R,Izz,...
p12x,p23x,pc1,pc2,pc3);

% specialized to 2D walker
% optimized to about 293 flops

cO1 = cos(y(1));
sO1 = sin(y(1));

cO2 = cos(y(2));
sO2 = sin(y(2));

cO3 = cos(y(3));
sO3 = sin(y(3));

R01=[cO1 -sO1 ;sO1 cO1];
R12=[cO2 -sO2 ;sO2 cO2];
R23=[cO3 -sO3 ;sO3 cO3];

R10=R01';
R21=R12';
R32=R23';

omega2 = y(4)+y(5);
omega3 = y(4)+y(5)+y(6);

v0=R*y(4);
v11=[v0*sO1 v0*cO1]';
v22=R21*[v11(1) y(4)*p12x+v11(2)]';
v33=R32*[v22(1) omega2*p23x+v22(2)]';

v1cm1 = v11+ddcross(y(4),pc1);
v2cm2 = v22+ddcross(omega2,pc2);
v3cm3 = v33+ddcross(omega3,pc3);

% sum angular momentum about hip before kneestrike
rhcm3 = [p23x*cO3 -p23x*sO3]'+pc3;
hpre(2)=crpr(rhcm3,m(3).*v3cm3)+Izz(3)*omega3+...
 crpr(pc2,m(2).*v2cm2)+Izz(2)*omega2;

% sum angular momentum about floor before kneestrike
r0cm1 = [R*cO1 -R*sO1]'+pc1;
r0cm2 = R21*[R*cO1+p12x -R*sO1]'+pc2;
r0cm3 = R32*(R21*([R*cO1+p12x -R*sO1]')+[p23x 0]')+pc3;
hpre(1) = crpr(r0cm1,m(1).*v1cm1)+Izz(1)*y(4)+...
 crpr(r0cm2,m(2).*v2cm2)+Izz(2)*omega2+...
 crpr(r0cm3,m(3).*v3cm3)+Izz(3)*omega3;

% Now do recursion to get matrix elements for hpost

v11=[R*sO1 R*cO1]';
v22=R21*[v11(1) p12x+v11(2)]';
v33=R32*[v22(1) p23x+v22(2)]';

v1cm1 = v11+[-pc1(2) pc1(1)]';
v2cm2 = v22+[-pc2(2) pc2(1)]';
v3cm3 = v33+[-pc3(2) pc3(1)]';

% sum angular momentum about hip after kneestrike
rhcm3 = [p23x*cO3 -p23x*sO3]'+pc3;
hpost(2,1)=crpr(rhcm3,m(3).*v3cm3)+Izz(3)+...
 crpr(pc2,m(2).*v2cm2)+Izz(2);

% sum angular momentum about floor after kneestrike
r0cm1 = R10*[R 0]'+pc1;
r0cm2 = R21*(R10*[R 0]'+[p12x 0]')+pc2;
r0cm3 = R32*(R21*(R10*[R 0]'+[p12x 0]')+[p23x 0]')+pc3;
hpost(1,1) = crpr(r0cm1,m(1).*v1cm1)+Izz(1)+...
 crpr(r0cm2,m(2).*v2cm2)+Izz(2)+...
 crpr(r0cm3,m(3).*v3cm3)+Izz(3);

% get second column of hpost

y(4)=0;
omega2=1;
omega3=1;

v33=R32*[0 p23x]';

v2cm2 = [-pc2(2) pc2(1)]';
v3cm3 = v33+[-pc3(2) pc3(1)]';

% sum angular momentum about hip after kneestrike
hpost(2,2)=crpr(rhcm3,m(3).*v3cm3)+Izz(3)+...
 crpr(pc2,m(2).*v2cm2)+Izz(2);
hpost(1,2) = hpost(2,1);
Odot = hpost\hpre';

ynew=[y(1) y(2) y(3) Odot(1) Odot(2) 0];
