function M = getmassmtrx(y);
global g gam m R p23 p34 pc3 pc4 p4f Icm3 Icm4 h hspr hoff hdamp

% code by Mariano Garcia (msg5@cornell.edu), 1998
% This file returns the mass matrix of the walker as a function
% of the state. It is the same routine as in yderivs_3D.m
% See that file for comments and documentation.

cO1 = cos(y(1));
sO1 = sin(y(1));

cO2 = cos(y(2));
sO2 = sin(y(2));

cO3 = cos(y(3));
sO3 = sin(y(3));

sO4 = sin(y(4));
cO4 = cos(y(4));


R01=[cO1 -sO1 0 ;sO1 cO1 0; 0 0 1];
R12=[cO2 -sO2 0 ;0 0 -1;sO2 cO2 0];
R23=[cO3 -sO3 0 ;0 0 -1;sO3 cO3 0];
R34=[cO4 -sO4 0 ;sO4 cO4 0; 0 0 1];

R10=R01';
R21=R12';
R32=R23';
R43=R34';

p233=R32*p23;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%     Now get mass matrix column by column         %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% construct column 1 by taking O1dotdot=1, all others =0
M=zeros(4);

omega1dot = [0 0 1]';

omega2dot=R21*omega1dot;

omega3dot=R32*omega2dot;

vdot3 = scross(omega3dot,p233);
vcdot3 = scross(omega3dot,pc3)+vdot3;

F3 = m(3)*vcdot3;
N3 = Icm3*omega3dot;

omega4dot=R43*omega3dot;

vdot4 = R43*(scross(omega3dot,p34)+vdot3);
vcdot4 = scross(omega4dot,pc4)+vdot4;

F4 = m(4)*vcdot4;
N4 = Icm4*omega4dot;

f4 = F4;
n4 = N4+scross(pc4,F4);
M(4,1) = n4(3);

f3 = R34*f4+F3;
n3 = N3+R34*n4+scross(pc3,F3)+scross(p34,R34*f4)-scross(-p233,f3);
M(3,1) = n3(3);

f2 = R23*f3;
n2 = R23*n3;%+scross(p23,R23*f3);
M(2,1) = n2(3);

n1 = R12*n2;
M(1,1) = n1(3);


%%%%%%%%%%%%%%%%%%%%%%%%%%%
% construct column 2 

omega2dot=[0 0 1]';

omega3dot=R32*omega2dot;

vdot3 = scross(omega3dot, p233);
vcdot3 = scross(omega3dot,pc3)+vdot3;

F3 = m(3)*vcdot3;
N3 = Icm3*omega3dot;

omega4dot=R43*omega3dot;

vdot4 = R43*(scross(omega3dot,p34)+vdot3);
vcdot4 = scross(omega4dot,pc4)+vdot4;

F4 = m(4)*vcdot4;
N4 = Icm4*omega4dot;

f4 = F4;
n4 = N4+scross(pc4,F4);
M(4,2) = n4(3);

f3 = R34*f4+F3;
n3 = N3+R34*n4+scross(pc3,F3)+scross(p34,R34*f4)-scross(-p233,f3);
M(3,2) = n3(3);

n2 = R23*n3;%+scross(p23,R23*f3);
M(2,2) = n2(3);

M(1,2) = M(2,1);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% construct column 3

omega3dot=[0 0 1]';

vdot3 = scross(omega3dot,p233);
vcdot3 = scross(omega3dot,pc3)+vdot3;

F3 = m(3)*vcdot3;
N3 = Icm3*omega3dot;

omega4dot=R43*omega3dot;

vdot4 = R43*(scross(omega3dot,p34)+vdot3);
vcdot4 = scross(omega4dot,pc4)+vdot4;

F4 = m(4)*vcdot4;
N4 = Icm4*omega4dot;

f4 = F4;
n4 = N4+scross(pc4,F4);
M(4,3) = n4(3);

f3 = R34*f4+F3;
n3 = N3+R34*n4+scross(pc3,F3)+scross(p34,R34*f4)-scross(-p233,f3);
M(3,3) = n3(3);

M(2,3) = M(3,2);

M(1,3) = M(3,1);



%%%%%%%%%%%%%%%%%%%%%%%%%%
% construct column 4 % careful w/ copy/pasting non-zero F3 and N3 here

omega4dot=[0 0 1]';

vcdot4 = scross(omega4dot,pc4);

F4 = m(4)*vcdot4;
N4 = Icm4*omega4dot;

f4 = F4;
n4 = N4+scross(pc4,F4);
M(4,4) = n4(3);

M(3,4) = M(4,3);

M(2,4) = M(4,2);

M(1,4) =M(4,1);

%pause(5);
