function theta4=zeroh1(y);

% Code by Mariano Garcia (msg5@cornell.edu), 1998

% given y, returns proper y(4) for foot contact.
% y must be close to standing correctly, or the thing
% may not converge or may converge to something wierd.

zecase = 'notsolved'; % Clouseau's flag for when the job is done

while (strcmp(zecase,'solved')==0) % do this loop until the
                                   % foot bottom height is
                                   % really tiny (< 1e-14).

junk = yderivs_3D(0,y);
 if length(junk) == 12  % yderivs returns different length vectors
                        % depending on whether we are doing forward
                        % integration with graphics (int_walker_3D.m)
                        % or gait fixed-point finding (it_3D_mcg.m)
                        % In either case, we want to set gold to the height
                        % of the bottom of the stance foot here.

   gold=junk(11); % in this case, we are doing forward integration.
 end;

 if length(junk) == 10
   gold=junk(9);  % in this case, we are doing gait-finding w/ no graphics
 end;

y(4) = y(4) + 1e-7;  % do a perturbation to get the slope

junk = yderivs_3D(0,y); % recalate foot height
 if length(junk) == 12
   gnew=junk(11); % junk(9) for it, junk(11) for int
 end;

 if length(junk) == 10
   gnew=junk(9);
 end;

y(4) = y(4) - 1e-7;  % undo the perturbation

dgdy4 = (gnew-gold)/1e-7;  % the 1x1 jacobian

dely4=dgdy4\(-gold)';  % calculate a swing angle delta

y(4) = y(4) + dely4;  % add the delta to the old swing angle

if abs(gold) < 1e-14  % check to see what the height is.
 zecase = 'solved';
end;

end;

theta4=y(4);

