function [t,y]=int_doubpend(t0,tfinal,tol,y0,beta,g,gam,l);
% kludge to run mex file- assumes g=l=1, stores [beta gamma] in BETA
betavec=[beta,gam,g];
% now there are two different betas floating around

global graphics m1 m2

%%%%%%%%%%%%%%%%%%%%%%%%%% Program begins  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Initialization
% The Fehlberg coefficients:
beta  = [ [    1      0      0     0      0    0]/4
          [    3      9      0     0      0    0]/32
          [ 1932  -7200   7296     0      0    0]/2197
          [ 8341 -32832  29440  -845      0    0]/4104
          [-6080  41040 -28352  9295  -5643    0]/20520 ]';
gamma = [ [902880  0  3953664  3855735  -1371249  277020]/7618050
          [ -2090  0    22528    21970    -15048  -27360]/752400 ]';

pow = 1/5;
f = zeros(length(y0),6);
if nargin < 5, tol = 0.001; end
t = t0;
hmax = (tfinal - t)/16;
h = hmax/8;
y = y0(:);
chunk = 128;
tout = zeros(chunk,1);
yout = zeros(chunk,length(y));

tau = tol * max(norm(y, 'inf'), 1);
if graphics == 1
clf reset;
axis([-1.5 1.5 -1.5 1.5]);
axis equal;
end;

% Get coordinates for graphics
% cfx,cfy are coordinates of center of stance foot in a world fixed frame
% hip, knee, and end are coordinates of hip, swing knee, and end foot center

hipx=-l*sin(y(1));
hipy=l*cos(y(1));

endx=hipx-l*sin(y(1)+y(2));
endy=hipy-l*cos(pi-y(1)-y(2));

if graphics ==1
%PLot graphics initially
walker_data=[0,0;hipx,hipy;endx,endy];
walker_bits=line('xdata',walker_data(:,1),'ydata',walker_data(:,2)...
,'erasemode','xor');
drawnow;
end;

%%%%%%%%%%%%%%%%%%%%%  Main Loop Begins  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
while  ((y(2)+h*y(4) <= pi-2*(y(1)+h*y(3))))...
& abs(y(1)) < pi/2 

% Compute the slopes
         f(:,1) = yderivs_doubpend(y,betavec(1),betavec(2),betavec(3),l);
            for j = 1:5
              f(:,j+1) = yderivs_doubpend(y+h*f*beta(:,j), ...
                         betavec(1),betavec(2),betavec(3),l);

            end


        % Estimate the error and the acceptable error
   delta = norm(h*f*gamma(:,2),'inf');
   tau = tol*max(norm(y,'inf'),1.0);


        % Update the solution only if the error is acceptable
        ts = t;
        ys = y;
        if delta <= tau
      	   t = t + h;
        y = y + h*f*gamma(:,1);
	   %Update Graphics



	hipx=-l*sin(y(1));
hipy=l*cos(y(1));

	endx=hipx-l*sin(y(1)+y(2));
	endy=hipy-l*cos(pi-y(1)-y(2));
if graphics ==1
	walker_data=[0,0;hipx,hipy;endx,endy];
        set(walker_bits,'xdata',walker_data(:,1),'ydata',walker_data(:,2));

	drawnow;
end;
	end;

        % Update the step size

      if delta ~= 0.0
      h = min(hmax, 0.9*h*(tau/delta)^pow);
     end
end;

while  ((y(2)+h*y(4) >= pi-2*(y(1)+h*y(3)))) ...
& abs(y(1)) < pi/2

 % Compute the slopes
         f(:,1) = yderivs_doubpend(y,betavec(1),betavec(2),betavec(3),l);
            for j = 1:5
              f(:,j+1) = yderivs_doubpend(y+h*f*beta(:,j), ...
                         betavec(1),betavec(2),betavec(3),l);

            end


        % Estimate the error and the acceptable error
   delta = norm(h*f*gamma(:,2),'inf');
   tau = tol*max(norm(y,'inf'),1.0);

        % Update the solution only if the error is acceptable
        ts = t;
        ys = y;
        if delta <= tau
           t = t + h;
y = y + h*f*gamma(:,1);
           %Update Graphics



        hipx=-l*sin(y(1));
        hipy=l*cos(y(1));

        endx=hipx-l*sin(y(1)+y(2));
        endy=hipy-l*cos(pi-y(1)-y(2));
if graphics ==1
        walker_data=[0,0;hipx,hipy;endx,endy];
        set(walker_bits,'xdata',walker_data(:,1),'ydata',walker_data(:,2));

        drawnow;
end;
        end;

        % Update the step size

      if delta ~= 0.0
      h = min(hmax, 0.9*h*(tau/delta)^pow);
     end
end;

    horig=h;

% now we are less than h seconds away from strike
	q=0;
if t<tfinal
	while q<6
	  h=(pi-2*y(1)-y(2))/(y(4)+2*y(3));

 % Compute the slopes
         f(:,1) = yderivs_doubpend(y,betavec(1),betavec(2),betavec(3),l);
            for j = 1:5
              f(:,j+1) = yderivs_doubpend(y+h*f*beta(:,j), ...
                         betavec(1),betavec(2),betavec(3),l);

            end


%don't worry about error computation in here, since h small enough
% assume solution is within tolerable error
	 
	  t = t + h;
y = y + h*f*gamma(:,1);

	  q=q+1;

end;
end;

%Update Graphics

        hipx=-l*sin(y(1));
	hipy=l*cos(y(1));
endx=hipx-l*sin(y(1)+y(2));
	endy=hipy-l*cos(pi-y(1)-y(2));
if graphics ==1
	walker_data=[0,0;hipx,hipy;endx,endy];
       set(walker_bits,'xdata',walker_data(:,1),'ydata',walker_data(:,2));


        drawnow;
  end;
h=horig;

% now we hit strike. AMB about strike point gives

Lvpre = -m1*l*y(3)*sin(y(1))

y(3)=(y(3)*cos(2*y(1)))/(1+betavec(1)*(sin(2*y(1)))^2);
y(4)=-y(3)*(1+cos(y(2)));

y(1)=-y(1);
y(2)=pi-2*y(1);

Lvpost = -m1*l*y(3)*sin(y(1)) + m2*(-2*l*sin(y(1))*y(3)*cos(y(1))-y(4)*l*sin(y(1)))



%%

