% Created by Mariano Garcia(garcia@tam.cornell.edu)
% Feb 1996 to find fixed points
% for pointfoot walker. Assumes that the file int_doubpend_step.m
% exists to take the initial conditions through one step
% and heelstrike and return the initial conditions for
% the next step.
format long
% leg parameters
global graphics
l = 1;
m1 = 1;
m2= 0;
beta=m2/m1;
graphics = 1;

% slope, foot radius,  and gravity

gam = 0.009;
g = 1;

%initial conditions

theta1 =  0.12196164739182;
theta2= pi-2*theta1;
theta1dot = -0.12535154656863;
theta2dot=-theta1dot*(1-cos(2*theta1));

%initial conditions gam=0.009
theta1 = 0.20031089581004;
theta2= pi-2*theta1;
theta1dot = -0.19983246430015;
theta2dot=-theta1dot*(1-cos(2*theta1));


y0 = [theta1 theta2 theta1dot theta2dot]

tol = 1e-10;
zeta = sqrt(tol); % good rule of thumb for forward difference
tfinal =12; % not necessary
n=0;
iterations=20;
fixedpoint = 'false';

while (strcmp(fixedpoint,'true')==0) & (n < iterations)

[t,y]=int_doubpend_step(0,tfinal,tol,y0,beta,g,gam,l); %get g
gold(1) = y(1)-y0(1);
gold(2) = y(3)-y0(3);

yg=y0; % perturb initial conditions, get column 1 of Jac of G
yg(1)=y0(1)+zeta;
yg(2)=pi-2*yg(1);
yg(4)=-yg(3)*(1-cos(2*yg(1)));

[t,y]=int_doubpend_step(0,tfinal,tol,yg,beta,g,gam,l);
gnew(1) = y(1)-yg(1);
gnew(2) = y(3)-yg(3);
dg(:,1)=(gnew-gold)';
jac(1)=y(1)-y0(1);
jac(2)=y(3)-y0(3);
J(:,1)=(jac./zeta)';

yg=y0; % perturb thetadot, get second column
yg(3)=y0(3)+zeta;
yg(4)=-yg(3)*(1-cos(2*yg(1)));

[t,y]=int_doubpend_step(0,tfinal,tol,yg,beta,g,gam,l);
gnew(1) = y(1)-yg(1);
gnew(2) = y(3)-yg(3);
dg(:,2)=(gnew-gold)';
jac(1)=y(1)-y0(1);
jac(2)=y(3)-y0(3);
J(:,2)=(jac./zeta)';


dgdy=(1/zeta).*dg

dely= dgdy\(-gold)' % get initial guess

y0(1)=y0(1)+dely(1);
y0(2)=pi-2*y0(1);
y0(3)=y0(3)+dely(2);
y0(4)=-y0(3)*(1-cos(2*y0(1)))

if abs(dely) < tol/10
fixedpoint = 'true'
end;

n=n+1
end;

I=eye(2); %compare eigenvalues
eig(dgdy+I)
eig(J)
